# Desenvolvimento frontend remoto
---

No momento a melhor solução que encontramos para o desenvolvimento usando Superset é: rodar o frontend local nas máquinas de cada dev, conectados ao backend de uma VM de desenvolvimento.

Aqui será passado apenas um passo-a-passo de como configurar e conectar com o Superset remoto, para a explicação do funcionamento acesse [Criação, teste e produção frontend Superset](gitlab.c3sl.ufpr.br/simcaq/depp-documentation/-/blob/main/Apache%20Superset/Criacao_teste_producao_do_frontend.md).

## Instalação, conexão e configuração do Superset remoto
---

#### 1. Programas necessários

Verifique se os seguintes programas estão instalados:

* git
* nvm
* node (usando nvm)

#### 2. Baixe o Superset

Faça a clonagem do repositório do [Superset do depp](gitlab.c3sl.ufpr.br/simcaq/superset) presente no gitlab, que é um fork do repositório oficial. 

```shell
git clone git@gitlab.c3sl.ufpr.br:simcaq/superset.git
```

#### 3. Configurar ambiente Node

Para confirmar que você está usando as versões corretas do `Node.js`(v.20) e do `npm`(v.10) usamo o nvm para versionamento.

```shell
# Saindo do diretório raiz
cd superset-frontend
nvm install --lts
nvm use --lts
```
#### 4. Instalar dependências

Instale as dependências listadas no `package.json`.

```shell
# No diretório superset-frontend
npm ci
```

> :warning: Caso o `package-lock.json` não esteja sincronizado com o `package.json` vai dar erro, nesse caso é necessário dar um `npm install` antes para atualizar a lista de dependências.

#### 5. Rodar o frontend local conectado ao remoto

```shell
npm run dev-server -- --env=--superset=http://endereco_maquina:porta
```

* Espere o webpack terminar de compilar, em seguida, entre no link disponível pelo **IPv4**.

> :warning: Pode ser necessário rodar alguns desses comandos usando `sudo`.

